package it.unibas.esempihibernate.es11bidir;

import it.unibas.esempihibernate.es1mbidir.Automobile;
import it.unibas.esempihibernate.util.DAOException;
import it.unibas.esempihibernate.util.PersistenceManager;
import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;

public class DAOStudente {
    
    public static Studente findByMatricola(int matricola) throws DAOException {
        Studente studente = null;
        try {
            Session session = PersistenceManager.getSession();
            Query query = session.createQuery("from Studente where matricola = ?");
            query.setInteger(0, matricola);
            List risultato = query.list();
            if (risultato.size() != 0) {
                studente = (Studente)risultato.get(0);
            }
        } catch (HibernateException e) {
            throw new DAOException(e);
        }
        return studente;
    }
    
    public static void makePersistent(Studente studente) throws DAOException {
        PersistenceManager.beginTransaction();
        try {
            PersistenceManager.getSession().saveOrUpdate(studente);
            PersistenceManager.commitTransaction();
        } catch (HibernateException e) {
            PersistenceManager.rollbackTransaction();
            throw new DAOException(e);
        }
    }
    
    public static void makeTransient(Studente studente) throws DAOException {
        PersistenceManager.beginTransaction();
        try {
            PersistenceManager.getSession().delete(studente);
            PersistenceManager.commitTransaction();
        } catch (HibernateException e) {
            PersistenceManager.rollbackTransaction();
            throw new DAOException(e);
        }
    }
}
