package it.unibas.esempihibernate.es11bidir;
import it.unibas.esempihibernate.util.DAOException;
import it.unibas.esempihibernate.util.PersistenceManager;
import java.util.ArrayList;
import java.util.List;
import org.hibernate.HibernateException;
import org.hibernate.Query;
import org.hibernate.Session;

public class DAOTirocinio {
    
    public static List findByAzienda(String azienda) throws DAOException {
        List risultato = new ArrayList();
        try {
            Session session = PersistenceManager.getSession();
            Query query = session.createQuery("from Tirocinio where azienda = ?");
            query.setString(0, azienda);
            risultato = query.list();
        } catch (HibernateException e) {
            throw new DAOException(e);
        }
        return risultato;
    }
    
    public static void makePersistent(Tirocinio tirocinio) throws DAOException {
        PersistenceManager.beginTransaction();
        try {
            PersistenceManager.getSession().saveOrUpdate(tirocinio);
            PersistenceManager.commitTransaction();
        } catch (HibernateException e) {
            PersistenceManager.rollbackTransaction();
            throw new DAOException(e);
        }
    }
    
    public static void makeTransient(Tirocinio tirocinio) throws DAOException {
        PersistenceManager.beginTransaction();
        try {
            PersistenceManager.getSession().delete(tirocinio);
            PersistenceManager.commitTransaction();
        } catch (HibernateException e) {
            PersistenceManager.rollbackTransaction();
            throw new DAOException(e);
        }
    }
}
