package it.unibas.esempihibernate.es1mbidir;

import java.util.ArrayList;
import java.util.List;

public class Proprietario {

    private long id;
    private String codiceFiscale;
    private String nome;
    private String cittaDiResidenza;
    private int annoPatente;
    private List automobili = new ArrayList();

    private void setId(long id){
        this.id = id;
    }

    public long getId(){
        return this.id;
    }

    public void setNome(String nome){
        this.nome = nome;
    }

    public void setCodiceFiscale(String codiceFiscale){
        this.codiceFiscale = codiceFiscale;
    }

    public void setCittaDiResidenza(String cittaDiResidenza){
        this.cittaDiResidenza = cittaDiResidenza;
    }

    public void setAnnoPatente(int annoPatente){
        this.annoPatente = annoPatente;
    }

    public String getNome(){
        return this.nome;
    }

    public String getCodiceFiscale(){
        return this.codiceFiscale;
    }

    public String getCittaDiResidenza(){
        return this.cittaDiResidenza;
    }

    public int getAnnoPatente() {
        return this.annoPatente;
    }

    public List getAutomobili() {
        return this.automobili;
    }

    public void setAutomobili(List automobili) {
        this.automobili = automobili;
    }

    public void addAutomobile(Automobile automobile) {
        this.automobili.add(automobile);
    }
    
    public Automobile getAutomobile(int i) {
        if (i < 0 || i >= automobili.size()) {
            return null;
        }
        return (Automobile)this.automobili.get(i);
    }

    public void eliminaAutomobile(int i) {
        if (i < 0 || i >= automobili.size()) {
            throw new IllegalArgumentException("Posizione scorretta");
        }
        this.automobili.remove(i);
    }

    public int getNumeroAutomobili() {
        return this.automobili.size();
    }

    public int cercaAutomobile(String targa) {
        for (int i = 0; i < automobili.size(); i++) {
            Automobile corrente = (Automobile)automobili.get(i);
            if (corrente.getTarga().equals(targa)) {
                return i;
            }
        }
        return -1;
    }

    public String toString() {
        return "[" + super.toString() + " - Id:" + this.id + ", CodiceFiscale: " + this.codiceFiscale
              + ", Nome: " + this.nome + ", CittaDiResidenza: " + this.cittaDiResidenza 
              + ", AnnoPatente: " + this.annoPatente + "]";  
    }
}



