package it.unibas.esempihibernate.test.persistenza.es11bidir;

import it.unibas.esempihibernate.es11bidir.DAOStudente;
import it.unibas.esempihibernate.es11bidir.DAOTirocinio;
import it.unibas.esempihibernate.es11bidir.Studente;
import it.unibas.esempihibernate.es11bidir.Tirocinio;
import it.unibas.esempihibernate.util.DAOException;
import it.unibas.esempihibernate.util.PersistenceManager;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import junit.framework.TestCase;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

public class Test11 extends TestCase {
 
    private static Log log = LogFactory.getLog(Test11.class);

    private Studente studente;
    private Tirocinio tirocinio;
    
    protected void setUp() {
        studente = new Studente();
        studente.setMatricola(1234);
        studente.setNome("Mario");
        tirocinio = new Tirocinio();
        tirocinio.setAzienda("Microsoft");
        Date data = new Date();
        GregorianCalendar calendario = new GregorianCalendar();
        calendario.setTime(data);
        tirocinio.setDataInizio(calendario);
    }
    
    public void testInserisciStudente() throws DAOException {
        Studente s = null;
        Tirocinio t = null;
        try {
            studente.setTirocinio(tirocinio);
            tirocinio.setStudente(studente);
            DAOStudente.makePersistent(studente);
            DAOTirocinio.makePersistent(tirocinio);
            PersistenceManager.closeSession();
            s = DAOStudente.findByMatricola(1234);
            assertNotNull(s);
            List tirocini = DAOTirocinio.findByAzienda("Microsoft");
            assertEquals(tirocini.size(), 1);
            t = (Tirocinio)tirocini.get(0);
            assertEquals(t.getAzienda(), "Microsoft");
        } catch (DAOException e) {
            log.error(e);
        } finally {
            DAOTirocinio.makeTransient(t);
            DAOStudente.makeTransient(s);
            PersistenceManager.closeSession();
        }
    }
    
}
