package it.unibas.esempihibernate.test.persistenza.esmmbidir;

import it.unibas.esempihibernate.esmmbidir.Autore;
import it.unibas.esempihibernate.esmmbidir.Libro;
import it.unibas.esempihibernate.util.DAOException;
import it.unibas.esempihibernate.util.PersistenceManager;
import java.util.List;
import junit.framework.TestCase;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.hibernate.Query;

public class Testmm extends TestCase {
 
    private static Log log = LogFactory.getLog(Testmm.class);

    private Autore autore1;
    private Autore autore2;
    private Libro libro1;
    private Libro libro2;
    
    protected void setUp() {
        autore1 = new Autore();
        autore1.setNome("Mario Rossi");
        autore2 = new Autore();
        autore2.setNome("Franco Bianchi");
        libro1 = new Libro();
        libro1.setTitolo("Titolo 1");
        libro1.setPrezzo(10.0);
        libro2 = new Libro();
        libro2.setTitolo("Titolo 2");
    }
    
    public void testInserisciAutore() {
        try {
            autore1.addLibro(libro1);
            autore1.addLibro(libro2);
            libro1.addAutore(autore1);
            libro2.addAutore(autore1);
            libro2.addAutore(autore2);
            autore2.addLibro(libro2);
            PersistenceManager.beginTransaction();
            PersistenceManager.getSession().save(autore1);
            PersistenceManager.commitTransaction();
            PersistenceManager.closeSession();
            Query query = PersistenceManager.getSession().createQuery("from Libro");
            List libri = query.list();
            assertEquals(libri.size(), 2);
            PersistenceManager.closeSession();
        } catch (DAOException e) {
            log.error(e);
            try {  
                PersistenceManager.rollbackTransaction();
            } catch (Exception ex) {}
        } finally {
            libro1.removeAutore(autore1);
            libro2.removeAutore(autore1);
            autore1.removeLibro(libro1);
            autore1.removeLibro(libro2);
            elimina(autore1);
            elimina(libro1);
            elimina(libro2);
            PersistenceManager.closeSession();
        }
    }
    
    private void elimina(Autore autore) {
        try {
            PersistenceManager.beginTransaction();
            PersistenceManager.getSession().delete(autore);
            PersistenceManager.commitTransaction();
        } catch (DAOException e) {
            log.error(e);
            try {  
                PersistenceManager.rollbackTransaction();
            } catch (Exception ex) {}
        } 
    }

    private void elimina(Libro libro) {
        try {
            PersistenceManager.beginTransaction();
            PersistenceManager.getSession().delete(libro);
            PersistenceManager.commitTransaction();
        } catch (DAOException e) {
            log.error(e);
            try {  
                PersistenceManager.rollbackTransaction();
            } catch (Exception ex) {}
        } 
    }
}
