create table automobili (
   id int8 not null,
   targa varchar(255) not null unique,
   modello varchar(255) not null,
   cilindrata int4 not null,
   idproprietario int8,
   primary key (id)
);
create table autori (
   idautore int8 not null,
   nome varchar(255) not null unique,
   primary key (idautore)
);
create table autorilibri (
   idautore int8 not null,
   idlibro int8 not null
);
create table libri (
   idlibro int8 not null,
   titolo varchar(255) not null unique,
   prezzo float8,
   primary key (idlibro)
);
create table proprietari (
   id int8 not null,
   codiceFiscale varchar(255) not null unique,
   nome varchar(255) not null,
   cittaDiResidenza varchar(255) not null,
   annoPatente int4 not null,
   primary key (id)
);
create table studenti (
   id int8 not null,
   matricola int4 not null unique,
   nome varchar(255) not null,
   primary key (id)
);
create table tirocini (
   id int8 not null,
   azienda varchar(255) not null,
   dataInizio timestamp,
   studente int8 unique,
   primary key (id)
);
alter table automobili add constraint FK15412F157486DAFF foreign key (idproprietario) references proprietari;
alter table autorilibri add constraint FK91B38F1664E6AA61 foreign key (idlibro) references libri;
alter table autorilibri add constraint FK91B38F1613C68087 foreign key (idautore) references autori;
alter table tirocini add constraint FK8D49E31365B6E4FC foreign key (studente) references studenti;
create table hibernate_unique_key (
    next_hi int4 
);
insert into hibernate_unique_key values ( 0 );
